Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1821)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! prr vertical dimensions set to nzb_do to nzt_do. Unused variables deleted.
 !
 ! Former revisions:
@@ -122,9 +122,7 @@
         
     USE control_parameters,                                                    &
-        ONLY:  avs_data_file, cloud_physics, do3d, do3d_avs_n,                 &
-               do3d_no, do3d_time_count, io_blocks, io_group,                  &
-               message_string, ntdim_3d,                                       &
-               nz_do3d, plot_3d_precision, psolver, simulated_time,            &
-               simulated_time_chr, skip_do_avs, time_since_reference_point
+        ONLY:  cloud_physics, do3d, do3d_no, do3d_time_count, io_blocks,       &
+               io_group, message_string, ntdim_3d, nz_do3d, psolver,           &
+               simulated_time, time_since_reference_point
         
     USE cpulog,                                                                &
@@ -132,6 +130,5 @@
         
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzt,  &
-               nzb
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb
         
     USE kinds
@@ -163,6 +160,4 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=9) ::  simulated_time_mod  !< 
-
     INTEGER(iwp) ::  av        !< 
     INTEGER(iwp) ::  i         !< 
@@ -173,7 +168,4 @@
     INTEGER(iwp) ::  nzb_do    !< vertical lower limit for data output
     INTEGER(iwp) ::  nzt_do    !< vertical upper limit for data output
-    INTEGER(iwp) ::  pos       !< 
-    INTEGER(iwp) ::  prec      !< 
-    INTEGER(iwp) ::  psi       !< 
 
     LOGICAL      ::  found     !< 
@@ -374,5 +366,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = prr(k,j,i)
                       ENDDO
@@ -383,5 +375,5 @@
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
+                      DO  k = nzb_do, nzt_do
                          local_pf(i,j,k) = prr_av(k,j,i)
                       ENDDO
Index: palm/trunk/SOURCE/data_output_dvrp.f90
===================================================================
--- palm/trunk/SOURCE/data_output_dvrp.f90	(revision 1821)
+++ palm/trunk/SOURCE/data_output_dvrp.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Particles and tails removed.
 ! 
 ! Former revisions:
@@ -58,5 +58,5 @@
 ! Description:
 ! ------------
-!> Plot of isosurface, particles and slicers with dvrp-software
+!> Plot of isosurface and slicers with dvrp-software
 !------------------------------------------------------------------------------!
  MODULE dvrp_color
@@ -130,11 +130,5 @@
         
     USE kinds
-    
-    USE particle_attributes,                                                   &
-        ONLY:  maximum_number_of_tailpoints, number_of_particles,              &
-               number_of_tails, particle_advection, particle_advection_start,  &
-               particle_tail_coordinates, particles, uniform_particles,        &
-               use_particle_tails
-        
+
     USE pegrid
 
@@ -234,149 +228,5 @@
 !--    Select the plot mode (in case of isosurface or slicer only if user has
 !--    defined a variable which shall be plotted; otherwise do nothing)
-       IF ( mode_dvrp(m)(1:9) == 'particles'  .AND.  particle_advection  .AND. &
-            simulated_time >= particle_advection_start )  THEN
-!
-!--       DVRP-Calls for plotting particles:
-          CALL cpu_log( log_point_s(28), 'dvrp_particles', 'start' )
-
-!
-!--       Definition of characteristics of particle material
-!          tmp_r = 0.1;  tmp_g = 0.7;  tmp_b = 0.1;  tmp_t = 0.0
-          tmp_r = 0.0_wp;  tmp_g = 0.0_wp;  tmp_b = 0.0_wp;  tmp_t = 0.0_wp
-          CALL DVRP_MATERIAL_RGB( m-1, 1, tmp_r, tmp_g, tmp_b, tmp_t )
-
-!
-!--       If clipping is active and if this subdomain is clipped, find out the
-!--       number of particles and tails to be plotted; otherwise, all
-!--       particles/tails are plotted. dvrp_mask is used to mark the partikles.
-          ALLOCATE( dvrp_mask(number_of_particles) )
-
-          IF ( dvrp_total_overlap )  THEN
-             dvrp_mask = .TRUE.
-             dvrp_nop  = number_of_particles
-             dvrp_not  = number_of_tails
-          ELSE
-             dvrp_mask = .FALSE.
-             dvrp_nop  = 0
-             dvrp_not  = 0
-             IF ( dvrp_overlap )  THEN
-                IF ( .NOT. use_particle_tails )  THEN
-                   DO  n = 1, number_of_particles
-                      ip = particles(n)%x / dx
-                      jp = particles(n)%y / dy
-                      IF ( ip >= nxl_dvrp  .AND.  ip <= nxr_dvrp  .AND.  &
-                           jp >= nys_dvrp  .AND.  jp <= nyn_dvrp )  THEN
-                         dvrp_nop = dvrp_nop + 1
-                         dvrp_mask(n) = .TRUE.
-                      ENDIF
-                   ENDDO
-                ELSE
-                   k = 0
-                   DO  n = 1, number_of_particles
-                      IF ( particles(n)%tail_id /= 0 )  THEN
-                         k = k + 1
-                         ip = particles(n)%x / dx
-                         jp = particles(n)%y / dy
-                         IF ( ip >= nxl_dvrp  .AND.  ip <= nxr_dvrp  .AND.  &
-                              jp >= nys_dvrp  .AND.  jp <= nyn_dvrp )  THEN
-                            dvrp_not = dvrp_not + 1
-                            dvrp_mask(n) = .TRUE.
-                         ENDIF
-                      ENDIF
-                   ENDDO
-                ENDIF
-             ENDIF
-          ENDIF
-
-!
-!--       Move particle coordinates to one-dimensional arrays
-          IF ( .NOT. use_particle_tails )  THEN
-!
-!--          All particles are output
-             ALLOCATE( psize(dvrp_nop), p_t(dvrp_nop), p_c(dvrp_nop), &
-                       p_x(dvrp_nop), p_y(dvrp_nop), p_z(dvrp_nop) )
-             psize = 0.0_wp;  p_t = 0_wp;  p_c = 0.0_wp
-             p_x = 0.0_wp; p_y = 0.0_wp
-             p_z   = 0.0_wp
-             k = 0
-             DO  n = 1, number_of_particles
-                IF ( dvrp_mask(n) )  THEN
-                   k = k + 1
-                   psize(k) = particles(n)%dvrp_psize
-                   p_x(k)   = particles(n)%x * superelevation_x
-                   p_y(k)   = particles(n)%y * superelevation_y
-                   p_z(k)   = particles(n)%z * superelevation
-                   p_c(k)   = particles(n)%class
-                ENDIF
-             ENDDO
-          ELSE
-!
-!--          Particles have a tail
-             ALLOCATE( psize(dvrp_not), p_t(dvrp_not),             &
-                       p_c(dvrp_not*maximum_number_of_tailpoints), &
-                       p_x(dvrp_not*maximum_number_of_tailpoints), &
-                       p_y(dvrp_not*maximum_number_of_tailpoints), &
-                       p_z(dvrp_not*maximum_number_of_tailpoints) )
-             psize = 0.0_wp;  p_t = 0_wp;  p_c = 0.0_wp
-             p_x = 0.0_wp;  p_y = 0.0_wp
-             p_z   = 0.0_wp
-             i = 0
-             k = 0
-
-             DO  n = 1, number_of_particles
-                nn = particles(n)%tail_id
-                IF ( nn /= 0  .AND.  dvrp_mask(n) )  THEN
-                   k = k + 1
-                   DO  j = 1, particles(n)%tailpoints
-                      i = i + 1
-                      p_x(i) = particle_tail_coordinates(j,1,nn) * &
-                                                                superelevation_x
-                      p_y(i) = particle_tail_coordinates(j,2,nn) * &
-                                                                superelevation_y
-                      p_z(i) = particle_tail_coordinates(j,3,nn) * &
-                                                                superelevation
-                      p_c(i) = particle_tail_coordinates(j,4,nn)
-                   ENDDO
-                   psize(k) = particles(n)%dvrp_psize
-                   p_t(k)   = particles(n)%tailpoints - 1
-                ENDIF                
-             ENDDO
-          ENDIF
-
-!
-!--       Compute and plot particles in dvr-format
-          IF ( uniform_particles  .AND.  .NOT. use_particle_tails )  THEN
-!
-!--          All particles have the same color. Use simple routine to set
-!--          the particle attributes (produces less output data)
-             CALL DVRP_PARTICLES( m-1, p_x, p_y, p_z, psize )
-          ELSE
-!
-!--          Set color definitions
-             CALL user_dvrp_coltab( 'particles', 'none' )
-
-             CALL DVRP_COLORTABLE_HLS( m-1, 0, interval_values_dvrp_prt, &
-                                       interval_h_dvrp_prt,              &
-                                       interval_l_dvrp_prt,              &
-                                       interval_s_dvrp_prt,              &
-                                       interval_a_dvrp_prt )
-
-             IF ( .NOT. use_particle_tails )  THEN
-                CALL DVRP_PARTICLES( m-1, dvrp_nop, p_x, p_y, p_z, 3, psize, &
-                                     p_c, p_t )
-             ELSE
-                CALL DVRP_PARTICLES( m-1, dvrp_not, p_x, p_y, p_z, 15, psize, &
-                                     p_c, p_t )
-             ENDIF
-          ENDIF
-
-          CALL DVRP_VISUALIZE( m-1, 3, dvrp_filecount )
-
-          DEALLOCATE( dvrp_mask, psize, p_c, p_t, p_x, p_y, p_z )
-
-          CALL cpu_log( log_point_s(28), 'dvrp_particles', 'stop' )
-
-
-       ELSEIF ( ( mode_dvrp(m)(1:10) == 'isosurface'  .OR.                     &
+       IF ( ( mode_dvrp(m)(1:10) == 'isosurface'  .OR.                     &
                   mode_dvrp(m)(1:6)  == 'slicer'           )                   &
                   .AND.  output_variable /= ' ' )  THEN
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1821)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Output of bulk microphysics simplified.
 !
 ! Former revisions:
@@ -193,7 +193,7 @@
     USE control_parameters,                                                    &
         ONLY:   average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
-                dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
+                dt_3d, g, humidity, kappa, large_scale_forcing,                &
                 large_scale_subsidence, max_pr_user, message_string, neutral,  &
-                ocean, passive_scalar, precipitation, simulated_time,          &
+                microphysics_seifert, ocean, passive_scalar, simulated_time,   &
                 use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
                 ws_scheme_mom, ws_scheme_sca
@@ -898,4 +898,6 @@
                       sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) *     &
                                                           rmask(j,i,sr)
+                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * rmask(j,i,sr)
+
                       IF ( .NOT. cloud_droplets )  THEN
                          pts = 0.5_wp *                                        &
@@ -906,25 +908,16 @@
                          sums_l(k,52,tn) = sums_l(k,52,tn) + pts * w(k,j,i) *  &
                                                              rmask(j,i,sr)
-                         IF ( icloud_scheme == 0  )  THEN
-                            sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) *    &
+                         sums_l(k,75,tn) = sums_l(k,75,tn) + qc(k,j,i) *       &
+                                                             rmask(j,i,sr)
+                         sums_l(k,76,tn) = sums_l(k,76,tn) + prr(k,j,i) *      &
+                                                             rmask(j,i,sr)
+                         IF ( microphysics_seifert )  THEN
+                            sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) *    &
                                                                 rmask(j,i,sr)
-                            sums_l(k,75,tn) = sums_l(k,75,tn) + qc(k,j,i) *    &
-                                                                rmask(j,i,sr)
-                            IF ( precipitation )  THEN
-                               sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) * &
-                                                                   rmask(j,i,sr)
-                               sums_l(k,74,tn) = sums_l(k,74,tn) + qr(k,j,i) * &
-                                                                   rmask(j,i,sr)
-                               sums_l(k,76,tn) = sums_l(k,76,tn) + prr(k,j,i) *&
-                                                                   rmask(j,i,sr)
-                            ENDIF
-                         ELSE
-                            sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) *    &
+                            sums_l(k,74,tn) = sums_l(k,74,tn) + qr(k,j,i) *    &
                                                                 rmask(j,i,sr)
                          ENDIF
-                      ELSE
-                         sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) *       &
-                                                             rmask(j,i,sr)
                       ENDIF
+
                    ELSE
                       IF( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
@@ -1662,9 +1655,9 @@
     USE control_parameters,                                                    &
         ONLY :  average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
-                dt_3d, g, humidity, icloud_scheme, kappa, large_scale_forcing, &
-                large_scale_subsidence, max_pr_user, message_string, neutral,  &
-                ocean, passive_scalar, precipitation, simulated_time,          &
-                use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
-                ws_scheme_mom, ws_scheme_sca
+                dt_3d, g, humidity, kappa, large_scale_forcing,                &
+                large_scale_subsidence, max_pr_user, message_string,           &
+                microphysics_seifert, neutral, ocean, passive_scalar,          &
+                simulated_time, use_subsidence_tendencies, use_surface_fluxes, &
+                use_top_fluxes, ws_scheme_mom, ws_scheme_sca
         
     USE cpulog,                                                                &
@@ -2774,5 +2767,5 @@
                 !$acc end parallel loop
 
-                IF ( icloud_scheme == 0  )  THEN
+                IF ( microphysics_seifert )  THEN
 
                    !$acc parallel loop gang present( qc, ql, rflags_invers, rmask, sums_l ) create( s1, s2 )
@@ -2791,26 +2784,22 @@
                    !$acc end parallel loop
 
-                   IF ( precipitation )  THEN
-
-                      !$acc parallel loop gang present( nr, qr, prr, rflags_invers, rmask, sums_l ) create( s1, s2, s3 )
-                      DO  k = nzb, nzt_diff
-                         s1 = 0
-                         s2 = 0
-                         s3 = 0
-                         !$acc loop vector collapse( 2 ) reduction( +: s1, s2, s3 )
-                         DO  i = nxl, nxr
-                            DO  j = nys, nyn
-                               s1 = s1 + nr(k,j,i)  * rmask(j,i,sr) * rflags_invers(j,i,k+1)
-                               s2 = s2 + qr(k,j,i)  * rmask(j,i,sr) * rflags_invers(j,i,k+1)
-                               s3 = s3 + prr(k,j,i) * rmask(j,i,sr) * rflags_invers(j,i,k+1)
-                            ENDDO
+                   !$acc parallel loop gang present( nr, qr, prr, rflags_invers, rmask, sums_l ) create( s1, s2, s3 )
+                   DO  k = nzb, nzt_diff
+                      s1 = 0
+                      s2 = 0
+                      s3 = 0
+                      !$acc loop vector collapse( 2 ) reduction( +: s1, s2, s3 )
+                      DO  i = nxl, nxr
+                         DO  j = nys, nyn
+                            s1 = s1 + nr(k,j,i)  * rmask(j,i,sr) * rflags_invers(j,i,k+1)
+                            s2 = s2 + qr(k,j,i)  * rmask(j,i,sr) * rflags_invers(j,i,k+1)
+                            s3 = s3 + prr(k,j,i) * rmask(j,i,sr) * rflags_invers(j,i,k+1)
                          ENDDO
-                         sums_l(k,73,tn) = s1
-                         sums_l(k,74,tn) = s2
-                         sums_l(k,76,tn) = s3
                       ENDDO
-                      !$acc end parallel loop
-
-                   ENDIF
+                      sums_l(k,73,tn) = s1
+                      sums_l(k,74,tn) = s2
+                      sums_l(k,76,tn) = s3
+                   ENDDO
+                   !$acc end parallel loop
 
                 ELSE
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1821)
+++ palm/trunk/SOURCE/header.f90	(revision 1822)
@@ -19,6 +19,6 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+! Tails removed. icloud_scheme replaced by microphysics_*
+!
 ! Former revisions:
 ! -----------------
@@ -275,12 +275,10 @@
                density_ratio, dissipation_classes, dt_min_part, dt_prel,       &
                dt_write_particle_data, end_time_prel,                          &
-               maximum_number_of_tailpoints, maximum_tailpoint_age,            &
-               minimum_tailpoint_distance, number_of_particle_groups,          &
-               particle_advection, particle_advection_start,                   &
+               number_of_particle_groups, particle_advection,                  &
+               particle_advection_start,                                       &
                particles_per_point, pdx, pdy, pdz,  psb, psl, psn, psr, pss,   &
                pst, radius, radius_classes, random_start_position,             &
                seed_follows_topography,                                        &
-               total_number_of_particles, use_particle_tails,                  &
-               use_sgs_for_particles, total_number_of_tails,                   &
+               total_number_of_particles, use_sgs_for_particles,               &
                vertical_particle_advection, write_particle_statistics
         
@@ -1700,14 +1698,4 @@
                                    slicer_range_limits_dvrp(:,m)
              ENDIF
-          ELSEIF ( mode_dvrp(i)(1:9) == 'particles' )  THEN
-             WRITE ( io, 363 )  dvrp_psize
-             IF ( particle_dvrpsize /= 'none' )  THEN
-                WRITE ( io, 364 )  'size', TRIM( particle_dvrpsize ), &
-                                   dvrpsize_interval
-             ENDIF
-             IF ( particle_color /= 'none' )  THEN
-                WRITE ( io, 364 )  'color', TRIM( particle_color ), &
-                                   color_interval
-             ENDIF
           ENDIF
           i = i + 1
@@ -1782,7 +1770,7 @@
        WRITE ( io, 415 )
        WRITE ( io, 416 ) surface_pressure, r_d, rho_surface, cp, l_v
-       IF ( icloud_scheme == 0 )  THEN
+       IF ( microphysics_seifert )  THEN
           WRITE ( io, 510 ) 1.0E-6_wp * nc_const
-          IF ( precipitation )  WRITE ( io, 511 ) c_sedimentation
+          WRITE ( io, 511 ) c_sedimentation
        ENDIF
     ENDIF
@@ -1796,14 +1784,12 @@
        WRITE ( io, 432 )
        IF ( cloud_top_radiation )  WRITE ( io, 132 )
-       IF ( icloud_scheme == 1 )  THEN
-          IF ( precipitation )  WRITE ( io, 133 )
-       ELSEIF ( icloud_scheme == 0 )  THEN
+       IF ( microphysics_kessler )  THEN
+          WRITE ( io, 133 )
+       ELSEIF ( microphysics_seifert )  THEN
           IF ( drizzle )  WRITE ( io, 506 )
-          IF ( precipitation )  THEN
-             WRITE ( io, 505 )
-             IF ( turbulence )  WRITE ( io, 507 )
-             IF ( ventilation_effect )  WRITE ( io, 508 )
-             IF ( limiter_sedimentation )  WRITE ( io, 509 )
-          ENDIF
+          WRITE ( io, 505 )
+          IF ( turbulence )  WRITE ( io, 507 )
+          IF ( ventilation_effect )  WRITE ( io, 508 )
+          IF ( limiter_sedimentation )  WRITE ( io, 509 )
        ENDIF
     ELSEIF ( humidity  .AND.  cloud_droplets )  THEN
@@ -1872,12 +1858,4 @@
        IF ( particles_per_point > 1 )  WRITE ( io, 489 )  particles_per_point
        WRITE ( io, 495 )  total_number_of_particles
-       IF ( use_particle_tails  .AND.  maximum_number_of_tailpoints /= 0 )  THEN
-          WRITE ( io, 483 )  maximum_number_of_tailpoints
-          IF ( minimum_tailpoint_distance /= 0 )  THEN
-             WRITE ( io, 484 )  total_number_of_tails,      &
-                                minimum_tailpoint_distance, &
-                                maximum_tailpoint_age
-          ENDIF
-       ENDIF
        IF ( dt_write_particle_data /= 9999999.9_wp )  THEN
           WRITE ( io, 485 )  dt_write_particle_data
@@ -2215,8 +2193,4 @@
 362 FORMAT (/'       Slicer plane ',A/ &
             '       Slicer limits: [',F6.2,',',F6.2,']')
-363 FORMAT (/'       Particles'/ &
-            '          particle size:  ',F7.2,' m')
-364 FORMAT ('          particle ',A,' controlled by "',A,'" with interval [', &
-                       F6.2,',',F6.2,']')
 365 FORMAT (/'       Groundplate color: (',F4.2,',',F4.2,',',F4.2,') (R,G,B)'/ &
             '       Superelevation along (x,y,z): (',F4.1,',',F4.1,',',F4.1, &
@@ -2377,8 +2351,4 @@
 481 FORMAT ('       Particles have random start positions'/)
 482 FORMAT ('          Particles are advected only horizontally'/)
-483 FORMAT ('       Particles have tails with a maximum of ',I3,' points')
-484 FORMAT ('            Number of tails of the total domain: ',I10/ &
-            '            Minimum distance between tailpoints: ',F8.2,' m'/ &
-            '            Maximum age of the end of the tail:  ',F8.2,' s')
 485 FORMAT ('       Particle data are written on file every ', F9.1, ' s')
 486 FORMAT ('       Particle statistics are written on file'/)
